#ifndef _DEMAND_H_
#define _DEMAND_H_


extern "C" {
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
}
#include <ecm.h>
#include <stream.h>
#include <rw/cstring.h>
#include <rw/ctoken.h>
#include <rw/collect.h>
#include <stringParse.H>
#include <sybaseConnection.H>
#include <unistd.h>
#include <BRInvestor.H>
#include <BRSalesPerson.H>


enum DemandType {
    BadDemand = -1,
    OrderAndTicket,
    Correction,
    AllocationOnly,
    UnMappedDemand,
    Cancellation,
    StepBid,
    SalespersonOnly,
    DeliverFactorOnly
};

   
class Demand: public RWCollectable 
{
public:

  // constructor
    /*    Demand(DBPROCESS *,char*,
	   int,int,int,
	   int,int,
	   int, char*, char*, char*,
	   int, char* , char*,
	   float, char*, float,
	   float, char*, char*,
	   char*, char*,
	   char*, int, char*,
	   char*, char*, char*); */
    
     Demand(DBPROCESS *,char*,
	   int,int,int,
	   int,int,
	   int, char*, char*, char*,
	   int, char* , char*,
	   double, char*, double,
	   double, char*, char*,
	   char*, char*,
	   char*, int, char*,
	   char*, char*, char*,double);
 
  // destructor
    ~Demand();

    DemandType demandType();
    int    isValid();
    void   printErrStatus();
    int    getRetPotRef();
    int    getRetPotRefAndTicket();
    void   SetDemandType();
    
    friend class Ticket;
    friend class Order;
    friend class Throttle;

    friend ostream& operator<<(ostream& os,Demand &d);
    friend ostream& operator<<(ostream& os,Order& order);
    friend ostream& operator<<(ostream& os,Ticket& ticket);
 
private:

  DBPROCESS* dbproc;
  
  int     demandHeaderID;
  int     demandIncrementID;
  int     demandSubHeaderID;
  int     demandHeaderStatusID;
  int     demandIncrementStatusID;
  int     managerID;
  char    manShortName[21];
  char    deliverFactor[11];
  char    deliverRule[11];
  int     investorID;
  char    starID[10];
  char    investorName[51];
  char    salespersonInitials[11];
  char    salesperson[20];
  double   allocation;
  char    demandHeaderCreatedDate[51];
  double   demand;
  double  demandLimitPrice;
  double  parValue;
    char    demandFactor[11];
  char    demandLimitFactor[51];
  char    demandIncrementTouchedDate[51];
  int     isInstitution;
  char    dealName[51];
  char    dealCode[21];
  int     trancheCode;
  char    allocComments[256];
  char    investorCountry[4];
  char    lastModifiedBy[16];
  BRSalesPerson *brSalesperson;
  BRInvestor *brInvestor;
  char	  originatorSystem[4];
  char	  originatorCpcode[21];
  char    originatorDept[6];
  char	  originatorKey[41];
  int     ticketCount;
  int	  ticket;
  int     valid;
  char    error_text[100];
  int	  flag;
  
};

#endif
