#ifndef _ORDER_H_
#define _ORDER_H_

#include <ecm.h>
#include "Demand.H"

class Order
{
public:
    Order(Demand *demand);
    ~Order();

    int isValid() {return valid;}
    void printErrStatus();
    int insert(DBPROCESS *dbproc);
    int updateAllocation(DBPROCESS *dbproc);
    int updateOrderForCorrection(DBPROCESS *dbproc);
    friend ostream& operator<<(ostream& os,Order& order);
    friend Demand;
  int flag;
  char error_text[100];
    
private:
    Demand*       myDemand;

    char	retPotFlag[2];
    char	deliverBy[21];
    char	nationCode[4];	
    char	cpCode[21];
    char	bidTypeCode[2];
    int 	source;
    float       lmScrubbedDemand;
    float       gcScrubbedDemand;
    char	dateStamp[51];
    char	deleted[2];
    int         valid;
    int         demandType;

  char          BRSalesPersonName[256];
  char          BRInvestorName[256];
  char          BRInvestorCode[21];

};

#endif
